
#ifndef __max_resources__
#define __max_resources__
const int MAXRESOURCES=15;
#endif

#ifndef __discharge_queue_h__
#define __discharge_queue_h__

#include <vector>

class Discharge_Entry {

private:
         int delegate;
         Replication_Info* replica;

public:
      Discharge_Entry(int del, Replication_Info* rep){
      	  delegate=del;
          replica=rep;
         }

      Discharge_Entry(Discharge_Entry* dis) {
          delegate=dis->getDelegate();
          replica=new Replication_Info(dis->getReplicationInfo());
          }

      int getDelegate(){return delegate;}
      Replication_Info* getReplicationInfo(){
         return new Replication_Info(replica);}


 };


class Discharge_Queue {
  private:
  Discharge_Entry* v[MAXRESOURCES];
	int len;

  public:

  Discharge_Queue(){
	    len=0;
	}

	int getLength(){return len;}
	void insert(int delegate, Replication_Info* rep)
	{
	 v[len]= new Discharge_Entry(delegate, rep);
	 len++;
	}

	Discharge_Entry* drawFirst() {
	   Discharge_Entry* entr=new Discharge_Entry(v[0]);
	   for(int j=0;j<len-1;j++)
	   	{
		  v[j]=v[j+1];
		}
	   len--;
	   return entr;
	  }

};


#endif

