
#ifndef __max_resources__
#define __max_resources__
const int MAXRESOURCES=15;
#endif

#ifndef __message_queue_h__
#define __message_queue_h__

#include <vector>

class Message_Entry {
      
private:
      int id;
      int delegate; //Ipoteticamente potrebbe essere [NODENUM]
      int copies;
	
public:
      Message_Entry(int res_id, int res_delegate, int res_copies){
      	  id=res_id;
	  delegate=res_delegate;
	  copies=res_copies;
         }
 
      int getId(){return id;}
      int getDelegate(){return delegate;}
      int getCopies(){return copies;}
      
      
 };    

        
class Message_Queue {
  private:
        Message_Entry* v[MAXRESOURCES];
	int v_len;
	
  public:
        
        Message_Queue(){
	    v_len=0;
	}      
	
	int getLength(){return v_len;}
	void insert(int res_id, int delegate, int num_replicas)
	{
	 v[v_len]= new Message_Entry(res_id, delegate, num_replicas);
	 v_len++;
	}
	
	Message_Entry* drawFirst() {
	   Message_Entry* entr=new Message_Entry(v[0]->getId(),v[0]->getDelegate(),v[0]->getCopies());
	   for(int j=0;j<v_len-1;j++)
	   	{
		  v[j]=v[j+1];
		}
	   v_len--;
	   return entr;
	  }
  
};
        

#endif

